FER_IsUpdating=true

FER_Defaults={
["DisplayMode"]="Combined",
["MaxBars"]=10,
["MaxFadeDistance"]=200,
["DPSMode"]=false,

["CountPreset"]=5,
["Count"]={[1]={1,1,1,1}, [5]={1,1,3,5}, [10]={2,2,6,10}},
["BarHeight"]=10,
["BarSpace"]=1,
["TextHeight"]=10,
["TextAlpha"]=0.75,
["PaneWidth"]=10,
["PaneSpace"]=5,

}

function FER_LoadSettings()
  if (not FER_Saved) then FER_Saved=FER_Defaults end
  for SetName, Val in pairs(FER_Defaults) do
    if (not FER_Saved[SetName]) then FER_Saved[SetName]=FER_Defaults[SetName] end --if
  end--do
end--function





FER_Colors = {
  ["HUNTER"]=     {["r"]=0.67, ["g"]=0.83, ["b"]=0.45},	--  Huntard		abd473
  ["WARLOCK"]=    {["r"]=0.58, ["g"]=0.51, ["b"]=0.79},	--  Lock		9482c9
  ["PRIEST"]=     {["r"]=1.00, ["g"]=1.00, ["b"]=1.00},	--  Priest		ffffff
  ["PALADIN"]=    {["r"]=0.96, ["g"]=0.55, ["b"]=0.73},	--  Allah-din	f58cba
  ["MAGE"]=       {["r"]=0.41, ["g"]=0.80, ["b"]=0.94},	--  Mage		69ccf0
  ["ROGUE"]=      {["r"]=1.00, ["g"]=0.96, ["b"]=0.41},	--  Rouge		FFF569
  ["DRUID"]=      {["r"]=1.00, ["g"]=0.50, ["b"]=0.00},	--  Drudd		FF7F00
  ["SHAMAN"]=     {["r"]=0.00, ["g"]=0.00, ["b"]=1.00},	--  Shammy		0000ff
  ["WARRIOR"]=    {["r"]=0.78, ["g"]=0.61, ["b"]=0.43},	--  Tank		C79C6E
  ["DEATHKNIGHT"]={["r"]=1.00, ["g"]=0.00, ["b"]=0.50}, --  Asshole		ff007f
  ["UNKNOWN"]=    {["r"]=0.25, ["g"]=0.25, ["b"]=0.25}};--  Unknown

--Data collected by Recount,RecountGuessedAbsorbs
--Recount.MainWindowData=DataTable
--Recount:SetMainWindowMode(Recount.db.profile.MainWindowMode or 1)


function FER_DetermineMode()

  return "Combined"
end--function

function FER_MakeBars(pane)
  --Pane
  --kill old
  --how many
end--function


function FER_FixLayout(mode)
  if mode=="Combined" then
	FER_Saved["DisplayMode"]="Combined"
    FumahEasyRecountMain:SetHeight(((FER_Saved["Count"][FER_Saved["CountPreset"]][1]+FER_Saved["Count"][FER_Saved["CountPreset"]][2]+FER_Saved["Count"][FER_Saved["CountPreset"]][3])*FER_Saved["BarHeight"])+((FER_Saved["Count"][FER_Saved["CountPreset"]][1]+FER_Saved["Count"][FER_Saved["CountPreset"]][2]+FER_Saved["Count"][FER_Saved["CountPreset"]][3]-3)*FER_Saved["BarSpace"])+(2*FER_Saved["PaneSpace"]))
	FumahEasyRecountMainTanks:ClearAllPoints()
	FumahEasyRecountMainHealers:ClearAllPoints()
	FumahEasyRecountMainDPSers:ClearAllPoints()
	
	FumahEasyRecountMainTanks:SetPoint("TOPLEFT", FumahEasyRecountMain, "TOPLEFT", 0, 0)
	FumahEasyRecountMainTanks:SetWidth(FER_Saved["PaneWidth"])
	FumahEasyRecountMainTanks:SetHeight( FER_Saved["Count"][FER_Saved["CountPreset"]][1]*FER_Saved["BarHeight"] + ((FER_Saved["Count"][FER_Saved["CountPreset"]][1]-1)*FER_Saved["BarSpace"]) )
	
	FumahEasyRecountMainHealers:SetPoint("TOPLEFT", FumahEasyRecountMainTanks, "BOTTOMLEFT", 0, -(FER_Saved["PaneSpace"]))
	FumahEasyRecountMainHealers:SetWidth(FER_Saved["PaneWidth"])
	FumahEasyRecountMainHealers:SetHeight( FER_Saved["Count"][FER_Saved["CountPreset"]][2]*FER_Saved["BarHeight"] + ((FER_Saved["Count"][FER_Saved["CountPreset"]][2]-1)*FER_Saved["BarSpace"]) )
	
	FumahEasyRecountMainDPSers:SetPoint("TOPLEFT", FumahEasyRecountMainHealers, "BOTTOMLEFT", 0, -(FER_Saved["PaneSpace"]))
	FumahEasyRecountMainDPSers:SetWidth(FER_Saved["PaneWidth"])
	FumahEasyRecountMainDPSers:SetHeight( FER_Saved["Count"][FER_Saved["CountPreset"]][3]*FER_Saved["BarHeight"] + ((FER_Saved["Count"][FER_Saved["CountPreset"]][3]-1)*FER_Saved["BarSpace"]) )
	
	FumahEasyRecountMainTanks:Show()
	FumahEasyRecountMainHealers:Show()
	FumahEasyRecountMainDPSers:Show()
	FER_ShowBars(FumahEasyRecountMainTanks,FER_Saved["Count"][FER_Saved["CountPreset"]][1], "FERTanks")
	FER_ShowBars(FumahEasyRecountMainHealers,FER_Saved["Count"][FER_Saved["CountPreset"]][2], "FERHealers")
	FER_ShowBars(FumahEasyRecountMainDPSers,FER_Saved["Count"][FER_Saved["CountPreset"]][3], "FERDPSers")
  elseif mode=="Tanks" then
    FER_Saved["DisplayMode"]="Tanks"
	FumahEasyRecountMain:SetHeight((FER_Saved["Count"][FER_Saved["CountPreset"]][4]*FER_Saved["BarHeight"])+((FER_Saved["Count"][FER_Saved["CountPreset"]][4]-1)*FER_Saved["BarSpace"]))
	FumahEasyRecountMainTanks:ClearAllPoints()
	FumahEasyRecountMainTanks:SetPoint("TOPLEFT", FumahEasyRecountMain, "TOPLEFT", 0, 0)
	FumahEasyRecountMainTanks:SetPoint("BOTTOMRIGHT", FumahEasyRecountMain, "BOTTOMLEFT", FER_Saved["PaneWidth"], 0)
	FumahEasyRecountMainTanks:Show()
	FumahEasyRecountMainHealers:Hide()
	FumahEasyRecountMainDPSers:Hide()
	FER_ShowBars(FumahEasyRecountMainTanks,FER_Saved["Count"][FER_Saved["CountPreset"]][4], "FERTanks")
  elseif mode=="Healers" then
    FER_Saved["DisplayMode"]="Healers"
	FumahEasyRecountMain:SetHeight((FER_Saved["Count"][FER_Saved["CountPreset"]][4]*FER_Saved["BarHeight"])+((FER_Saved["Count"][FER_Saved["CountPreset"]][4]-1)*FER_Saved["BarSpace"]))
	FumahEasyRecountMainHealers:ClearAllPoints()
	FumahEasyRecountMainHealers:SetPoint("TOPLEFT", FumahEasyRecountMain, "TOPLEFT", 0, 0)
	FumahEasyRecountMainHealers:SetPoint("BOTTOMRIGHT", FumahEasyRecountMain, "BOTTOMLEFT", FER_Saved["PaneWidth"], 0)
	FumahEasyRecountMainTanks:Hide()
	FumahEasyRecountMainHealers:Show()
	FumahEasyRecountMainDPSers:Hide()
	FER_ShowBars(FumahEasyRecountMainHealers, FER_Saved["Count"][FER_Saved["CountPreset"]][4], "FERHealers")
  elseif mode=="DPSers" then
	FER_Saved["DisplayMode"]="DPSers"
	FumahEasyRecountMain:SetHeight((FER_Saved["Count"][FER_Saved["CountPreset"]][4]*FER_Saved["BarHeight"])+((FER_Saved["Count"][FER_Saved["CountPreset"]][4]-1)*FER_Saved["BarSpace"]))
	FumahEasyRecountMainDPSers:ClearAllPoints()
	FumahEasyRecountMainDPSers:SetPoint("TOPLEFT", FumahEasyRecountMain, "TOPLEFT", 0, 0)
	FumahEasyRecountMainDPSers:SetPoint("BOTTOMRIGHT", FumahEasyRecountMain, "BOTTOMLEFT", FER_Saved["PaneWidth"], 0)
	FumahEasyRecountMainTanks:Hide()
	FumahEasyRecountMainHealers:Hide()
	FumahEasyRecountMainDPSers:Show()
	FER_ShowBars(FumahEasyRecountMainDPSers, FER_Saved["Count"][FER_Saved["CountPreset"]][4], "FERDPSers")
  end
end--function

function FER_ShowBars(Pane, Number, Bar)
for i=1,Number do
  getglobal(Bar..i):SetPoint("TOPLEFT", Pane, "TOPRIGHT",1,-(((i-1)*FER_Saved["BarHeight"])+((i-1)*FER_Saved["BarSpace"])))
  getglobal(Bar..i):SetPoint("RIGHT", FumahEasyRecountMain, "RIGHT",0,0)
  --getglobal(Bar..i):SetWidth(FumahEasyRecountMain:GetWidth()-15)
  getglobal(Bar..i):SetHeight(FER_Saved["BarHeight"])
  getglobal(Bar..i.."1"):SetHeight(FER_Saved["BarHeight"])
  getglobal(Bar..i.."2"):SetHeight(FER_Saved["BarHeight"])
  getglobal(Bar..i):SetID(i)
  getglobal(Bar..i):Show()
  --getglobal(Bar..i.."Text2"):SetText(FER_grpNr(math.floor(12000000*math.random())))
  --getglobal(Bar..i.."Text1"):SetText(i..". Temporary")
end--do
for i=Number+1,FER_Saved["MaxBars"] do
  getglobal(Bar..i):Hide()
end--do
end--function

function FER_CreateBars()
  for i=1,FER_Saved["MaxBars"] do
    CreateFrame("Frame", "FERTanks"..i, FumahEasyRecountMainTanks, "FumahEasyRecountBarTemplate")
	CreateFrame("Frame", "FERHealers"..i, FumahEasyRecountMainHealers, "FumahEasyRecountBarTemplate")
	CreateFrame("Frame", "FERDPSers"..i, FumahEasyRecountMainDPSers, "FumahEasyRecountBarTemplate")
	--getglobal("FERTanks"..i):SetID(i)
	--getglobal("FERHealers"..i):SetID(i)
	--getglobal("FERDPSers"..i):SetID(i)
  end--do
end--function

function FER_grpNr(theNumber)
local N = math.floor(theNumber)
  if strlen(N)>3 and strlen(N)<7 then
    theNumber=strsub(N,1,strlen(N)-3).."."..strsub(N,strlen(N)-2,strlen(N))
  elseif strlen(theNumber)>6 then
    theNumber=strsub(N,1,strlen(N)-6).."."..strsub(N,strlen(N)-5,strlen(N)-3).."."..strsub(N,strlen(N)-2,strlen(N))
  end
return theNumber
end--function

function FER_ReportData()
FER_IsUpdating=true
FER_Data={}
doInclude={["DRUID"]=true,["PRIEST"]=true,["WARRIOR"]=true,["WARLOCK"]=true,["SHAMAN"]=true,["HUNTER"]=true,["ROGUE"]=true,["PALADIN"]=true,["DEATHKNIGHT"]=true, ["MAGE"]=true}
local data=Recount.db2.combatants
local i=0
  for k,v in pairs(data) do
   if doInclude[data[k].enClass] then
	if type(data[k])=="table" then
	 if data[k].Fights[Recount.db.profile.CurDataSet] then
      i=i+1
	  --FRUP(i..". "..k..": "..data[k].enClass)
      local healing,hps = Recount:MergedPetHealingDPS(data[k],Recount.db.profile.CurDataSet)
      local damage, dps = Recount:MergedPetDamageDPS(data[k],Recount.db.profile.CurDataSet)
      local damagetaken = data[k].Fights[Recount.db.profile.CurDataSet].DamageTaken or 0
      local healingtaken = data[k].Fights[Recount.db.profile.CurDataSet].HealingTaken or 0
      local absorbs, aps = data[k].Fights[Recount.db.profile.CurDataSet].GuessedAbsorbs or 0, (data[k].Fights[Recount.db.profile.CurDataSet].GuessedAbsorbs or 0)/((data[k].Fights[Recount.db.profile.CurDataSet].ActiveTime or 0) + 0.000000000000000001)

	  FER_Data[k]={}
	  FER_Data[k]["Class"]=data[k].enClass
	  FER_Data[k]["Combined"]=healing+absorbs
	  FER_Data[k]["CombinedPerSec"]=hps+aps
	  FER_Data[k]["Healing"]=healing
	  FER_Data[k]["HealingPerSec"]= hps
	  FER_Data[k]["Absorbs"]=absorbs
	  FER_Data[k]["AbsorbsPerSec"]=aps
	  FER_Data[k]["DamageDone"]=damage
	  FER_Data[k]["DamageDonePerSec"]=dps
	  FER_Data[k]["DamageTaken"]=damagetaken
	  FER_Data[k]["HealingTaken"]=healingtaken 
	 end--if
	end--if
   end--if
  end--do
  
  FER_Sorted={}
  FER_Sorted["Tanks"]={}
  FER_Sorted["Healers"]={}
  FER_Sorted["DPSers"]={}
  local Hi, Ti, Di=0,0,0
  --Sort FER_Tables
  for name,_ in pairs(FER_Data) do
    if FER_Saved["DPSMode"]==true then
      if FER_Data[name]["CombinedPerSec"] > 0 then Hi = Hi + 1; FER_Sorted["Healers"][Hi]=name end
	  if FER_Data[name]["DamageTaken"] > 0 then Ti = Ti + 1; FER_Sorted["Tanks"][Ti]=name end
	  if FER_Data[name]["DamageDonePerSec"] > 0 then Di = Di + 1; FER_Sorted["DPSers"][Di]=name end
	else
      if FER_Data[name]["Combined"] > 0 then Hi = Hi + 1; FER_Sorted["Healers"][Hi]=name end
	  if FER_Data[name]["DamageTaken"] > 0 then Ti = Ti + 1; FER_Sorted["Tanks"][Ti]=name end
	  if FER_Data[name]["DamageDone"] > 0 then Di = Di + 1; FER_Sorted["DPSers"][Di]=name end
	end--if
  end--do
  for i=1,getn(FER_Sorted["Tanks"]) do
    local Count=getn(FER_Sorted["Tanks"])
    local FromPos,ToPos=ReturnHighest("Tanks",i,Count),i
	local Temp=FER_Sorted["Tanks"][ToPos]
	FER_Sorted["Tanks"][ToPos]=FER_Sorted["Tanks"][FromPos]
	FER_Sorted["Tanks"][FromPos]=Temp
  end--do
  for i=1,getn(FER_Sorted["Healers"]) do
    local Count=getn(FER_Sorted["Healers"])
    local FromPos,ToPos= ReturnHighest("Healers",i,Count),i
	local Temp=FER_Sorted["Healers"][ToPos]
	FER_Sorted["Healers"][ToPos]=FER_Sorted["Healers"][FromPos]
	FER_Sorted["Healers"][FromPos]=Temp
  end--do
  for i=1,getn(FER_Sorted["DPSers"]) do
  local Count=getn(FER_Sorted["DPSers"])
    local FromPos,ToPos= ReturnHighest("DPSers",i,Count),i
	local Temp=FER_Sorted["DPSers"][ToPos]
	FER_Sorted["DPSers"][ToPos]=FER_Sorted["DPSers"][FromPos]
	FER_Sorted["DPSers"][FromPos]=Temp
  end--do
  
FER_IsUpdating=false
end--function

function ReturnHighest(Who,From,Count)
local stat={}
  if FER_Saved["DPSMode"]==true then
	stat={["Tanks"]="DamageTaken",["Healers"]="CombinedPerSec",["DPSers"]="DamageDonePerSec"}
  else
    stat={["Tanks"]="DamageTaken",["Healers"]="Combined",["DPSers"]="DamageDone"}
  end
  local highest=From
  for personID = From,Count do
    if FER_Data[FER_Sorted[Who][personID]][stat[Who]]>FER_Data[FER_Sorted[Who][highest]][stat[Who]] then highest=personID end
  end--do
  return highest
end--function


function FER_CheckMouseDistance()
  local x, y = GetCursorPosition()
  x,y=x/UIParent:GetScale(),y/UIParent:GetScale()
  local cx, cy = FumahEasyRecountMain:GetCenter()
  local xdist, ydist = abs(cx-x), abs(cy-y)
  local distance = sqrt((xdist*xdist)+(ydist*ydist))  --a2 + b2 = h2 
  local x1,y1 = FumahEasyRecountTitle:GetLeft(), FumahEasyRecountTitle:GetTop()
  local x1dist, y1dist= abs(cx-x1), abs(cy-y1)
  local mindistance=sqrt((x1dist*x1dist)+(y1dist*y1dist))
  local maxdistance=mindistance+FER_Saved["MaxFadeDistance"]
  if distance<mindistance then
    FumahEasyRecountTitle:SetAlpha(1)
	FumahEasyRecountSubTitle:SetAlpha(1)
  elseif distance>maxdistance then
    FumahEasyRecountTitle:SetAlpha(0)
	FumahEasyRecountSubTitle:SetAlpha(0)
  else
    local alpha=1-((distance-mindistance)/mindistance)
    FumahEasyRecountTitle:SetAlpha(alpha)
	FumahEasyRecountSubTitle:SetAlpha(alpha)
  end--if
end--function

function FER_Report(Channel, ToPerson)
local SortMode

if FER_Saved["DPSMode"]==true then SortMode="sorted by DPS/HPS+APS" else SortMode="sorted by Value" end
  SendChatMessage("F.Ea.R. Report "..SortMode, Channel, "Common", ToPerson);
  if Recount.FightName then SendChatMessage(Recount.FightName, Channel, "Common", ToPerson) end
  if FumahEasyRecountMainTanks:IsVisible() then
    local total=0
	for i=1,getn(FER_Sorted["Tanks"]) do
	  total=total+FER_Data[FER_Sorted["Tanks"][i]]["DamageTaken"]
	end--do
    SendChatMessage("Tanks - damage taken:", Channel, "Common", ToPerson);
    for i=1,FER_Saved["MaxBars"] do
      if getglobal("FERTanks"..i):IsVisible() then
	    local name=FER_Sorted["Tanks"][i]
        SendChatMessage(" "..i..". "..name.." - "..FER_grpNr(FER_Data[name]["DamageTaken"]).."  "..string.format("%01.2f",(FER_Data[name]["DamageTaken"]/total)*100).."%", Channel, "Common", ToPerson);
	  else
	    break
	  end--if
	end--do
  end--if
  
  if FumahEasyRecountMainHealers:IsVisible() then
    local total=0
	for i=1,getn(FER_Sorted["Healers"]) do
	  total=total+FER_Data[FER_Sorted["Healers"][i]]["Combined"]
	end--do
    SendChatMessage("Healers - healing+absorbs (hps+aps):", Channel, "Common", ToPerson);
    for i=1,FER_Saved["MaxBars"] do
      if getglobal("FERHealers"..i):IsVisible() then
	    local name=FER_Sorted["Healers"][i]
        SendChatMessage(" "..i..". "..name.."  -  "..FER_grpNr(FER_Data[name]["Combined"]).."  ("..FER_grpNr(floor(FER_Data[name]["CombinedPerSec"]))..")  "..string.format("%01.2f",(FER_Data[name]["Combined"]/total)*100).."%", Channel, "Common", ToPerson);
	  else
	    break
	  end--if
	end--do
  end--if
  
  if FumahEasyRecountMainDPSers:IsVisible() then
    local total=0
	for i=1,getn(FER_Sorted["DPSers"]) do
	  total=total+FER_Data[FER_Sorted["DPSers"][i]]["DamageDone"]
	end--do
    SendChatMessage("DPSers - damage done (dps):", Channel, "Common", ToPerson);
    for i=1,FER_Saved["MaxBars"] do
      if getglobal("FERDPSers"..i):IsVisible() then
	    local name=FER_Sorted["DPSers"][i]
        SendChatMessage(" "..i..". "..name.."  -  "..FER_grpNr(FER_Data[name]["DamageDone"]).."  ("..FER_grpNr(floor(FER_Data[name]["DamageDonePerSec"]))..")  "..string.format("%01.2f",(FER_Data[name]["DamageDone"]/total)*100).."%", Channel, "Common", ToPerson);
	  else
	    break
	  end--if
	end--do
  end--if
  
  SendChatMessage("Data collected by Recount, Recount Guessed Absorbs", Channel, "Common", ToPerson);
end--Function

function FER_InitReport(Channel,ToPerson)
  FERReportConfirmChannel:SetText(Channel)
  if Channel=="WHISPER" then
    FERReportConfirmToPerson:Show()
	FERReportConfirm:SetHeight(85)
	if UnitExists("target") and UnitIsPlayer("target") and UnitIsFriend("target","player") then
	  FERReportConfirmToPerson:SetText(UnitName("target"))
	else
	  FERReportConfirmToPerson:SetText("")
	end
  else
    FERReportConfirmToPerson:SetText("")
    FERReportConfirmToPerson:Hide()
	FERReportConfirm:SetHeight(85-12-3)
  end
  FERReportConfirm:Show()
end--function

function FER_SlashCommand(msg)
local cmd=strmatch(msg,"^(%w+)%s?")
  if cmd=="killtooltip" then
    if FER_Saved["KillTooltip"] then
	  FER_Saved["KillTooltip"]=nil
	  print("FumahEasyRecount: TooltipDisplay ON.")
	else
	  FER_Saved["KillTooltip"]=1
	  print("FumahEasyRecount: TooltipDisplay OFF.")
	end
  else
    print("FumahEasyRecount: slashcommand  /fer killtooltip   toggles tooltip display.")
  end  
end--function